--Copyright (C) 2015 Zen Lu and released under the GPLv3

library ieee;
use ieee.std_logic_1164.all;
use work.fpoinc_pkg.all;

package fpo_pkg is

  component fpo is
    port (clk, ena, vclk, vena, ps2clk, ps2ena, reset, trg_input : in std_ulogic; d : fpo_data_typ; ps2c, ps2d : inout std_ulogic; vc : out vgaout);
  end component;

end fpo_pkg;

library ieee;
use ieee.std_logic_1164.all;
use work.fpoinc_pkg.all;
use work.fpocore_pkg.all;
use work.videomode_pkg.all;
use work.mousectrl_pkg.all;

entity fpo is
  port (clk, ena, vclk, vena, ps2clk, ps2ena, reset, trg_input : in std_ulogic; d : fpo_data_typ; ps2c, ps2d : inout std_ulogic; vc : out vgaout);
end fpo;

architecture arch_fpo of fpo is

  signal capture_ctrl : capture_ctrl_rec;
  signal display_ctrl : display_ctrl_rec;
  signal xcursor      : col_typ;
  signal valid        : std_ulogic;

begin

  mouse_ctrl : mousectrl port map(
    clk          => ps2clk,
    ena          => ps2ena,
    reset        => reset,
    ps2c         => ps2c,
    ps2d         => ps2d,
    capture_ctrl => capture_ctrl,
    display_ctrl => display_ctrl,
    xcursor      => xcursor,
    update       => valid);

  fpo_core : fpocore port map(
    clk          => clk,
    ena          => ena,
    vclk         => vclk,
    vena         => vena,
    trg_input    => trg_input,
    d            => d,
    capture_ctrl => capture_ctrl,
    display_ctrl => display_ctrl,
    xcursor      => xcursor,
    vc           => vc);

end arch_fpo;
