--Copyright (C) 2015 Zen Lu and released under the GPLv3

library ieee;
use ieee.std_logic_1164.all;

package fpotyp_pkg is

  type trg_mod_typ is (norm, sngl);     --auto

  constant scale_typ_low  : natural  := 0;
  constant scale_typ_high : positive := 3;

  subtype scale_typ is natural range scale_typ_low to scale_typ_high;

  type vgamode_typ is (e_800x600_72, e_1280x1024_75);

  type trace_typ_typ is (tt_bit16, tt_bus16w4, tt_dot64u, tt_bar64u, tt_bar256u, tt_separ4);  --mosaic16

  type trace_property_typ is record
    width : natural;
    lines : natural;
  end record;

  type trace_properties_typ is array (trace_typ_typ) of trace_property_typ;

  constant trace_properties : trace_properties_typ :=
    (
      (1, 16),
      (4, 16),
      (6, 64),
      (6, 64),
      (8, 256),
      (0, 4)
      );

  type trace_config_typ is record
    trace_typ : trace_typ_typ;
  end record;

  type fpo_config_typ is array (natural range <>) of trace_config_typ;

end fpotyp_pkg;
