--Copyright (C) 2015 Zen Lu and released under the GPLv3

library ieee;
use ieee.std_logic_1164.all;
use work.fpocfg_pkg.all;

package trireg_pkg is

  component trireg is
    port (clk, ena : in std_ulogic; wsel, vsel : in std_ulogic_vector(2 downto 0); idrift : in drift_typ; iadr : in ramadr_typ; odrift : out drift_typ; oadr : out ramadr_typ);
  end component;

end trireg_pkg;

library ieee;
use ieee.std_logic_1164.all;
use work.fpocfg_pkg.all;

entity trireg is
  port (clk, ena : in std_ulogic; wsel, vsel : in std_ulogic_vector(2 downto 0); idrift : in drift_typ; iadr : in ramadr_typ; odrift : out drift_typ; oadr : out ramadr_typ);
end trireg;

architecture arch_trireg of trireg is

  signal adrift, bdrift, cdrift : drift_typ;
  signal aadr, badr, cadr       : ramadr_typ;

begin

  process(clk)
  begin
    if rising_edge(clk) then
      if '1' = ena then
        if '1' = wsel(0) then
          adrift <= idrift;
          aadr   <= iadr;
        end if;
        if '1' = wsel(1) then
          bdrift <= idrift;
          badr   <= iadr;
        end if;
        if '1' = wsel(2) then
          cdrift <= idrift;
          cadr   <= iadr;
        end if;
      end if;
    end if;
  end process;

  odrift <= adrift when ('1' = vsel(0)) else bdrift when ('1' = vsel(1)) else cdrift;

  oadr <= aadr when ('1' = vsel(0)) else badr when ('1' = vsel(1)) else cadr;

end arch_trireg;
