--Copyright (C) 2015 Zen Lu and released under the GPLv3

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use work.fpotyp_pkg.all;

package fpocfg_pkg is

  constant ramlength : positive := 2048;

-----BEGIN OF DO NOT TOUCH------------------------------
  constant ramadr_typ_low  : natural  := 0;
  constant ramadr_typ_high : positive := ramlength - 1;

  subtype ramadr_typ is natural range ramadr_typ_low to ramadr_typ_high;

  constant drift_typ_low  : integer  := -32768;
  constant drift_typ_high : positive := ramlength - 1;

  subtype drift_typ is integer range drift_typ_low to drift_typ_high;
-----END OF DO NOT TOUCH------------------------------

  constant scale_default   : scale_typ   := 0;
  constant drift_default   : drift_typ   := 300;  --16;
  constant disp_default    : ramadr_typ  := 0;
  constant trgmode_default : trg_mod_typ := norm;
  constant act_default     : std_ulogic  := '1';
  constant depth_default   : ramadr_typ  := 1024 - 1;

  constant vgamode : vgamode_typ := e_800x600_72;  -- e_1280x1024_75;

  constant traceval_enable : boolean := true;

  constant fpo_config : fpo_config_typ :=
    ((trace_typ => tt_bit16),

     (trace_typ => tt_separ4),

     (trace_typ => tt_bit16),
     (trace_typ => tt_bit16),
     (trace_typ => tt_bit16),
     (trace_typ => tt_bit16),
     (trace_typ => tt_bit16),
     (trace_typ => tt_bit16),
     (trace_typ => tt_bit16),
     (trace_typ => tt_bit16),

     (trace_typ => tt_separ4),

     (trace_typ => tt_bus16w4),
     (trace_typ => tt_bus16w4),

     (trace_typ => tt_separ4),

     (trace_typ => tt_bar256u),

     (trace_typ => tt_separ4),

     (trace_typ => tt_bus16w4),
     (trace_typ => tt_bus16w4),

     (trace_typ => tt_separ4),

     (trace_typ => tt_dot64u),

     (trace_typ => tt_separ4),

     (trace_typ => tt_bit16),
     (trace_typ => tt_bit16));

end fpocfg_pkg;
