library ieee;
use ieee.std_logic_1164.all;
use work.fpoinc_pkg.all;
use work.fpocfg_pkg.all;
use work.fpocore_pkg.all;

entity test is
end test;

architecture arch_test of test is

  signal clk, vclk                    : std_logic            := '0';
  signal ena                          : std_logic            := '0';
  signal cnt                          : natural range 0 to 4 := 0;
  signal d                            : fpo_data_typ         := (others => '0');
  signal vc_r, vc_g, vc_b, vc_h, vc_v : std_logic;
  signal vc                           : vgaout;

  signal capture_ctrl : capture_ctrl_rec :=
    (
      act   => act_default,
      mode  => trgmode_default,
      depth => depth_default,
      drift => drift_default
      );

  signal display_ctrl : display_ctrl_rec :=
    (
      scale => scale_default,
      disp  => disp_default
      );

begin

  ena <= not ena when rising_edge(clk);

  process (clk)
  begin
    if rising_edge(clk) then
      clk <= '0' after 50 ns, '1' after 100 ns;
    elsif not falling_edge(clk) then
      clk <= '0', '1' after 100 ns;
      report "(re)start clk";
    end if;
  end process;

  process (vclk)
  begin
    if rising_edge(vclk) then
      vclk <= '0' after 10 ns, '1' after 20 ns;
    elsif not falling_edge(vclk) then
      vclk <= '0', '1' after 20 ns;
      report "(re)start vclk";
    end if;
  end process;

  process (clk)
  begin
    if rising_edge(clk) then
      if '1' = ena then
        if 4 > cnt then
          cnt <= cnt + 1;
        else
          cnt  <= 0;
          d(0) <= not d(0);
        end if;
      end if;
    end if;
  end process;

  fpo_core : fpocore port map(
    clk          => clk,
    ena          => ena,
    vclk         => vclk,
    vena         => '1',
    trg_input    => d(0),
    d            => d,
    capture_ctrl => capture_ctrl,
    display_ctrl => display_ctrl,
    xcursor      => (others => '0'),
    vc           => vc);

  vc_r <= vc.r;
  vc_g <= vc.g;
  vc_b <= vc.b;
  vc_h <= vc.h;
  vc_v <= vc.v;

end arch_test;
